<?php
namespace Teknisa\PLA\Modules\Cardapio\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DataSource\DataSet;

class Pla00106AnaliseCustoOrigemController extends \Teknisa\GER\Controllers\TeknisaCrud {

    const UNIDADEOL = 'analisecustounidadeol';
    const ORIGEM = 'analisecustoorigem';
    const PREFERENCIAL = 'analisecustopreferencial';

    protected $parameterBagColumns;
    protected $dataSourceManager;

     public function __construct($crudService, $parameterBag, $dataSourceManager) {
     	$this->crudService = $crudService;
     	$this->parameterBag = $parameterBag;
     	$this->dataSourceManager = $dataSourceManager;
    }

    public function retornaUnidadeOL(DTO\Request $request, DTO\Response $response) {

		$conditions = $request->getFilterCriteria()->getConditions();

		$nrorg = $conditions[0]['value'];
		$cdfilial = $conditions[1]['value'];
		$cdproduto = $conditions[2]['value'];

		$filterCriteria = new FilterCriteria(self::UNIDADEOL);
		$this->parameterBagColumns = array('NRORG', 'CDFILIAL', 'CDPRODUTO');

		$filterCriteria->addCondition('NRORG', $nrorg);
		$filterCriteria->addCondition('CDFILIAL', $cdfilial);
		$filterCriteria->addCondition('CDPRODUTO', $cdproduto);

		$newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, $this->parameterBagColumns);

		$dataSet = $this->dataSourceManager->findBy($newFilterCriteria);

		$dataSet->setDataSourceName('filial');
		
		$response->addDataSet($dataSet);
    }

    public function retornaOrigem(DTO\Request $request, DTO\Response $response) {

		$conditions = $request->getFilterCriteria()->getConditions();

		$nrorg = $conditions[0]['value'];
		$cdfilial = $conditions[1]['value'];
		$cdproduto = $conditions[2]['value'];
		$dtrefecusto = $conditions[3]['value'];
		$nrtipocusto = $conditions[4]['value'];

		$dataSetOrigem = $this->retornaDataSetOrigem($nrorg, $cdfilial, $cdproduto, $dtrefecusto, $nrtipocusto);
		$dataSetPreferencial = $this->retornaDataSetPreferencial($nrorg, $cdfilial, $cdproduto, $dtrefecusto, $nrtipocusto);

		$rowsOrigem = $dataSetOrigem->getRows();
		$rowPreferencial = $dataSetPreferencial->getRows();

		if(isset($rowPreferencial[0])) {
			$rowsOrigem[0]['CDPRODPREF']    = $rowPreferencial[0]['CDPRODPREF'];
			$rowsOrigem[0]['CDARVPRODPREF'] = $rowPreferencial[0]['CDARVPRODPREF'];
			$rowsOrigem[0]['NMPRODPREF']    = $rowPreferencial[0]['NMPRODPREF'];
		} else {
			$rowsOrigem[0]['CDPRODPREF']    = '';
			$rowsOrigem[0]['CDARVPRODPREF'] = '';
			$rowsOrigem[0]['NMPRODPREF']    = '';
		}
		
		$response->addDataSet(new DataSet(self::ORIGEM, $rowsOrigem));
    }

    private function retornaDataSetOrigem($nrorg, $cdfilial, $cdproduto, $dtrefecusto, $nrtipocusto) {
    	$filterCriteria = new FilterCriteria(self::ORIGEM);
		$this->parameterBagColumns = array('NRORG', 'CDFILIAL', 'CDPRODUTO', 'DTREFECUSTO', 'NRTIPOCUSTO');

		$filterCriteria->addCondition('NRORG', $nrorg);
		$filterCriteria->addCondition('CDFILIAL', $cdfilial);
		$filterCriteria->addCondition('CDPRODUTO', $cdproduto);
		$filterCriteria->addCondition('DTREFECUSTO', $dtrefecusto);
		$filterCriteria->addCondition('NRTIPOCUSTO', $nrtipocusto);

		$newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, $this->parameterBagColumns);

		$dataSet = $this->dataSourceManager->findBy($newFilterCriteria);

		return $dataSet;
    }

    private function retornaDataSetPreferencial($nrorg, $cdfilial, $cdproduto) {
    	$filterCriteria = new FilterCriteria(self::PREFERENCIAL);
		$this->parameterBagColumns = array('NRORG', 'CDFILIAL', 'CDPRODUTO');

		$filterCriteria->addCondition('NRORG', $nrorg);
		$filterCriteria->addCondition('CDFILIAL', $cdfilial);
		$filterCriteria->addCondition('CDPRODUTO', $cdproduto);
		$newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, $this->parameterBagColumns);

		$dataSet = $this->dataSourceManager->findBy($newFilterCriteria);

		return $dataSet;
    }
}